-- (c) MP-I and CP (1998/99-2007/08)

-- NB: this is not a library, it is just a script of demos.
-- The useful material can be found in libraries BTree.hs and LTree.hs

import BTree
import LTree
import Exp


--- (a) BTree virtual data structure display ----------------------------------

--- Quicksort ------------------------------------------------------------------
qSort_vtree x = ((expDisplay "_.html") . cBTree2Exp .
                (fmap show) . (anaBTree qsep)) x
--- Towers of Hanoi ------------------------------------------------------------
hanoi_vtree =
	expDisplay "_.html" .
        cBTree2Exp .
        (fmap show) .
        (anaBTree strategy)

--- (b) LTree virtual data structure display -----------------------------------

--- Fibonacci ------------------------------------------------------------------
fib_vtree n = ((expDisplay "_.html") . cLTree2Exp .
              (fmap show) . (anaLTree fibd)) n
--- Mergesort ------------------------------------------------------------------
mSort_vtree [] = (expDisplay "_.html") (Var " ")
mSort_vtree l = ((expDisplay "_.html") . cLTree2Exp .
		(fmap show) . (anaLTree lsplit )) l
-- Double factorial ------------------------------------------------------------
dfac_vtree 0 = (expDisplay "_.html") (Var "1")
dfac_vtree n = ((expDisplay "_.html") . cLTree2Exp .
               (fmap show) . (anaLTree dfacd)) (1,n)

-- (c) Auxiliary functions -----------------------------------------------------
cLTree2Exp = cataLTree (either Var h)
	     where h(a,b) = Term "Fork" [a,b] 
--------------------------------------------------------------------------------
cBTree2Exp :: BTree a -> Exp [Char] a
cBTree2Exp = cataBTree (either (const (Var "nil")) h)
	     where h(a,(b,c)) = Term a [c,b] 
