-- (c) MP-I and CP (1998/99-2006/07)
---
--- mobile phone directory example,
--- cf. slides 10 to 12 in www.di.uminho.pt/~jno/ps/msdn02.zip
---

import Cp
import St
import SMT

-- (a) functional layer ----------------------------------------

npush10 :: Eq a => a -> [a] -> [a]
npush10 n = (take 10) . (npush n)
            where npush n s = [n] ++ (filter (/=n) s)

-- (b) reactive layer (St monadic) ----------------------------------

store n = St((split length id) . npush10 n)

del n = St((split length id) . tail . npush10 n)

call n = St((split head id) . npush10 n)

-- storebatch l = sequence_ (do i <- l ; return (store i)) -- cf [ store i | i <- l ] 

clear = modify (const [])

-- (c) interactive layer (M = IO + St) ------------------------------

mob :: SMT [String] IO ()
mob = do { x <- iM(do { putStr "\n Call which number? " ;
			 getLine });
		 -- record call in list
         iSt (call x) ;
		 -- actual call involves IO
         iM (writeFile "_call_number.txt" x) ; -- emulates actual calling protocol
		 -- show call list
         y <- iSt (get) ;
	 iM(putStr (show y))
       }

-- compare with unsafe program without monadic glue (all effects together)
-- which, of course, doesn't typecheck:
--
--  do { x <- do { putStr "\n Call which number? " ; getLine };
--       call x;
--       writeFile "_call_number.txt" x) ;
--       y <- get ;
--       putStr (show y)
--     }

-- (d) main process -------------------------------------------------

main :: IO a
main = runSMT (loop mob) []

